<?php
function cSpriteAdminMenuChecksFailed(){
 add_options_page(__('cSprites Options', CSPRITE_PLUGIN_NAME), __('cSprites', CSPRITE_PLUGIN_NAME), 8, __FILE__, 'cSpriteOptionsPageChecksFailed');
}
function cSpriteAdminMenu() {
  add_options_page(__('cSprites Options', CSPRITE_PLUGIN_NAME), __('cSprites', CSPRITE_PLUGIN_NAME), 8, __FILE__, 'cSpriteOptionsPage');
}

function cSpriteClearCache(){
  remove_action('update_option_cSpriteClearCacheNow', 'cSpriteClearCache');
  if(isset($_REQUEST['cSpriteClearCacheNow'])){
    Sprite::clearCache();
  }
  update_option('cSpriteClearCacheNow', 0);
  return 0;
}

function cSpriteOptionsPage(){

?>
<div class="wrap">


<h2><?php _e('cSprites for Wordpress', CSPRITE_PLUGIN_NAME);?></h2>

<form method="post" action="options.php">
<?php wp_nonce_field('update-options'); ?>
<table class="form-table">
<tr><td colspan="2"><span style="font-size:large;text-decoration:underline;"><?php _e('Quality & Style Settings', CSPRITE_PLUGIN_NAME);?></span></td></tr>
<tr valign="top">
<th scope="row"><label for="cSpriteJpgQuality"><?php _e('JPG Quality',CSPRITE_PLUGIN_NAME);?></label></th>
<td>
<div id="jpgCompressionSlider" style="width:300px"></div>
<?php _e('Quality', CSPRITE_PLUGIN_NAME);?>: <input type="text" id="cSpriteJpgQuality" name="cSpriteJpgQuality" style="width:3em; font-weight:bold;" value="<?php echo get_option('cSpriteJpgQuality'); ?>"/>
<span class="setting-description"><?php _e('0 lowest - 100 highest (Default: 70)', CSPRITE_PLUGIN_NAME);?></span></td>
</tr>

<tr valign="top">
<th scope="row"><label for="cSpritePngCompression"><?php _e('PNG Compression', CSPRITE_PLUGIN_NAME);?></label></th>
<td>
<div id="pngCompressionSlider" style="width:300px"></div>
<?php echo _e('Compression', CSPRITE_PLUGIN_NAME);?>: <input type="text" id="cSpritePngCompression" name="cSpritePngCompression" style="width:3em; font-weight:bold;" value="<?php echo get_option('cSpritePngCompression'); ?>"/>
<span class="setting-description"><?php _e('0 lowest - 9 highest (Default: 9)', CSPRITE_PLUGIN_NAME);?></span></td>
</tr>

<tr valign="top">
<th scope="row"><label for="cSpriteForceNoPadding"><?php _e('Force no padding in image style', CSPRITE_PLUGIN_NAME);?></label></th>
<td>
<input type="checkbox" class="cSpriteCheckbox" name="cSpriteForceNoPadding" id="cSpriteForceNoPadding" <?php echo (get_option('cSpriteForceNoPadding'))?(' checked="checked" '):('');?> />
    <span class="setting-description"><?php _e('turning this on will add a <strong>padding:0 !important;</strong> style to each image class; this will prevent padding from exposing other parts of the sprite. (Default: true)', CSPRITE_PLUGIN_NAME);?></span>
    </td>
</tr>

<tr><td colspan="2"><span style="font-size:large;text-decoration:underline;"><?php _e('Include or exclude certain image types from processing',CSPRITE_PLUGIN_NAME);?></span></td></tr>

<tr valign="top">
<th scope="row"><label for="cSpriteProcessJpg"><?php _e('Process JPG images', CSPRITE_PLUGIN_NAME);?></label></th>
<td><input type="checkbox" class="cSpriteCheckbox" name="cSpriteProcessJpg" id="cSpriteProcessJpg" <?php echo (get_option('cSpriteProcessJpg'))?(' checked="checked" '):('');?> />
    </td>
</tr>

<tr valign="top">
<th scope="row"><label for="cSpriteProcessGif"><?php _e('Process GIF images', CSPRITE_PLUGIN_NAME);?></label></th>
<td><input type="checkbox" class="cSpriteCheckbox" name="cSpriteProcessGif" id="cSpriteProcessGif" <?php echo (get_option('cSpriteProcessGif'))?(' checked="checked" '):('');?> />
    </td>
</tr>
<tr valign="top">
<th scope="row"><label for="cSpriteProcessPng"><?php _e('Process PNG images', CSPRITE_PLUGIN_NAME);?></label></th>
<td><input type="checkbox" class="cSpriteCheckbox" name="cSpriteProcessPng" id="cSpriteProcessPng" <?php echo (get_option('cSpriteProcessPng'))?(' checked="checked" '):('');?> />
    <span class="setting-description"><?php _e('Due to the way PHP handles PNG files, the resulting sprite may be larger than the sum of the original file sizes', CSPRITE_PLUGIN_NAME);?></span>
    </td>
</tr>

<tr><td colspan="2"><span style="font-size:large;text-decoration:underline;"><?php _e('Cache Settings',CSPRITE_PLUGIN_NAME);?></span></td></tr>

<tr valign="top">
<th scope="row"><label for="cSpriteCacheTime"><?php _e('Cache Time in Minutes', CSPRITE_PLUGIN_NAME);?></label></th>
<td><input type="text" name="cSpriteCacheTime" id="cSpriteCacheTime" value="<?php echo get_option('cSpriteCacheTime'); ?>" style="width:6em;"/><span class="setting-description"><?php _e('set to 0 for no cache (Default: 20)', CSPRITE_PLUGIN_NAME);?></span></td>
</tr>

<tr valign="top">
<th scope="row"><label for="cSpriteClearCacheNow"><?php _e('Clear cSprite Cache', CSPRITE_PLUGIN_NAME);?></label></th>
<td><input type="checkbox" class="cSpriteCheckbox" name="cSpriteClearCacheNow" id="cSpriteClearCacheNow"/>
    <span class="setting-description"><?php _e('Immediately deletes all the files in the cSprite cache. May help with images not displaying properly.', CSPRITE_PLUGIN_NAME);?></span>
    </td>
</tr>

</table>

<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="cSpriteJpgQuality,cSpritePngCompression,cSpriteCacheTime,cSpriteForceNoPadding,cSpriteClearCacheNow,cSpriteProcessJpg,cSpriteProcessPng,cSpriteProcessGif" />

<p class="submit">
<input type="submit" class="button-primary" value="<?php _e('Save Changes', CSPRITE_PLUGIN_NAME) ?>" />
</p>

</form>
<img id="cSpriteEmptyImage" src="<?php echo CSPRITE_TRANS_GIF_URL;?>" style="display:none;"/>
</div>
<?php 
} //end function 

function cSpriteOptionsPageChecksFailed(){
?>
<div class="wrap">
<h2><?php _e('cSprites for Wordpress', CSPRITE_PLUGIN_NAME);?></h2>
<h3><?php _e('The following problems occurred in your installation', CSPRITE_PLUGIN_NAME);?>:</h3>
<?php if(!cSpriteCheckCacheWritable()):?>
  <div style="background-color: rgb(255, 251, 204);" id="message" class="error"><p>The directory: <strong><em><?php echo CSPRITE_CACHE_DIR; ?></em></strong> was not writable. Please modify permissions.</p></div>
<?php endif; ?>
<?php if(!cSpriteCheckPhpVersion()): ?>
  <div style="background-color: rgb(255, 251, 204);" id="message" class="error"><p>You are currently running PHP <strong><?php echo phpversion(); ?></strong>. cSprites only supports PHP versions &gt; <strong>5.0.0</strong></p></div>
<?php endif; ?>
<?php if(!cSpriteCheckWordPressVersion()): ?>
  <div style="background-color: rgb(255, 251, 204);" id="message" class="error"><p>You are currently running an unsupported version of Wordpress. cSprites only supports Wordpress versions &gt;= <strong>2.7</strong></p></div>
<?php endif; ?>

<h4><?php _e('In order to run cSprites please fix these problems and refresh this screen.', CSPRITE_PLUGIN_NAME);?></h4>
<?php
}
?>